/**
 * Utility methods
 */ 
var Util = {
    
    log: 
		function(msg) {
    		dump(msg +'\n');   
		},
	
	properties:
		function(obj) {
			var props = '';
			for (var p in obj) { props += p +', ' };
			props = props.slice(0, props.length-2);
			FB.OBJ.log(props);
		},
		
	dumpObj:
		function(obj) {
			for (var p in obj) {
				FB.OBJ.log(p +': '+ obj[p]);
			}
		},
		
	escapeXML:
		function(str) {
			return str.replace(/&/g, '&amp;').replace(/\'/g, '&apos;').replace(/\"/g, '&quot;');
		},
		
	escapeURL:
		function(url) {
			return escape(url).replace(/%3A/, ':');
		},
		
	directory:
		function(name) {
			var extension = Components.classes['@mozilla.org/extensions/manager;1'].
								getService(Components.interfaces.nsIExtensionManager).
								getInstallLocation(FB.OBJ.EXTENSION_ID).
								getItemLocation(FB.OBJ.EXTENSION_ID);
			var dirname = extension.path + FB.OBJ.PATH_SEP + 
							'chrome' + FB.OBJ.PATH_SEP + 
							'content' + FB.OBJ.PATH_SEP + 
							name;
			var dir = DirIO.open(dirname);
			if ( ! dir.exists() ) {
				dir.create(0x01, 0774);
			}
			return dir;
		},
		
	getCharPref:
		function(prefName) {
			var prefManager = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefBranch);
			try {
				return prefManager.getCharPref('extensions.foxden.'+ prefName);
			}
			catch (e) {
				return null;
			}
		},
		
	setCharPref:
		function(prefName, value) {
			var trimmedValue = FB.OBJ.trim(value);
			var prefManager = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefBranch);
			return prefManager.setCharPref('extensions.foxden.'+ prefName, trimmedValue);
		},
		
    getBoolPref:
        function(prefName) {
            var prefManager = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefBranch);
			try {
				return prefManager.getBoolPref('extensions.foxden.'+ prefName);
			}
			catch (e) {
				return false;
			}
        },
        
    clearPref:
        function(prefName) {
            var prefManager = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefBranch);
			
			try {
                prefManager.clearUserPref('extensions.foxden.'+ prefName);
            }
            catch (e) {} // the pref might not be set
        },
        
	mimeType:
		function(filename) {

			var ext = filename.slice( filename.length-3, filename.length ); 

			var mimeService = Components.classes["@mozilla.org/mime;1"].
								getService(Components.interfaces.nsIMIMEService);
			try {
				var mimeInfo = mimeService.getTypeFromExtension(ext);
				return mimeInfo;
			}
			catch (e) {
				return "binary/octet-stream";
			}
		},
		
	trim:
		function(value) {
			return value.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
		},
		
	contains:
		function contains(arr, obj) {
  			var i = arr.length;
  			while (i--) {
    			if (arr[i] === obj) {
      				return true;
    			}
  			}
  			return false;
		},
		
	open:
		function(url) {
			FB.OBJ._openAndReuseOneTabPerAttribute('firbucket', url);
		},
		
	_openAndReuseOneTabPerAttribute:	// https://developer.mozilla.org/en/Code_snippets/Tabbed_browser
		function(attrName, url) {
		  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		           .getService(Components.interfaces.nsIWindowMediator);
		  for (var found = false, index = 0, tabbrowser = wm.getEnumerator('navigator:browser').getNext().getBrowser();
		       index < tabbrowser.mTabs.length && !found;
		       index++) {
		
		    // Get the next tab
		    var currentTab = tabbrowser.mTabs[index];
		  
		    // Does this tab contain our custom attribute?
		    if (currentTab.hasAttribute(attrName)) {
		
		      // Yes--select and focus it.
		      tabbrowser.selectedTab = currentTab;
		
		      // Focus *this* browser in case another one is currently focused
		      tabbrowser.loadURI(url, tabbrowser.currentURI, "UTF-8");
		      tabbrowser.focus();

		      found = true;
		    }
		  }
		
		  if (!found) {
		    // Our tab isn't open. Open it now.
		    var browserEnumerator = wm.getEnumerator("navigator:browser");
		    var tabbrowser = browserEnumerator.getNext().getBrowser(); 
		  
		    // Create tab
		    var newTab = tabbrowser.addTab(url);
		    newTab.setAttribute(attrName, "xyz");
		  
		    // Focus tab
		    tabbrowser.selectedTab = newTab;
		    
		    // Focus *this* browser in case another one is currently focused
		    tabbrowser.focus();
		  }
		},

	isoDateTime:
		function(d) {

			function pad(c) {
				c = new String(c);
				if (c.length < 2) {
					c = '0'+ c;
				}
				return c;
			}

			if (!d) {
				d = new Date();
			}

			var iso = d.getUTCFullYear() +'-'+ pad(d.getUTCMonth()) +'-'+ pad(d.getUTCDay()) +'T'+ 
					pad(d.getUTCHours()) +':'+ pad(d.getUTCMinutes()) +':'+ pad(d.getUTCSeconds()) +'.000Z';
					
			return iso;
		},
        
    urlToLocalFile:
        function(localURL) {
            var ios = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
            var protocolHandler = ios.getProtocolHandler("file")
                     .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
            var file = protocolHandler.getFileFromURLSpec(localURL);
            return file.path;
        }
}